
camera = {}
camera.x = 0
camera.y = 0
camera.speed = 20
camera.rotation = 0
camera.defaultZoom = 1
camera.zoom = camera.defaultZoom


function camera:follow(dt) --My function boi
  local screenWidth = love.graphics.getWidth() * camera.zoom
  local screenHeight = love.graphics.getHeight() * camera.zoom
  local camTop = 160
  camera.x = camera.x - (camera.x - (player.x - screenWidth / 2)) * dt * camera.speed
  if player.y <= camTop then
  camera.y = camera.y - (camera.y - (player.y + player.h / 2 - screenHeight / 2)) * dt * camera.speed/10
else if player.y >= camTop then
  camera.y = camera.y - camera.y * dt * camera.speed/10
end
end
end
function camera:set()
  love.graphics.push()
  love.graphics.rotate(-self.rotation)
  love.graphics.scale(1 / self.zoom, 1 / self.zoom)
  love.graphics.translate(-self.x, -self.y)
end
function camera:unset()
  love.graphics.pop()
end
function camera:move(dx, dy)
  self.x = self.x + (dx or 0)
  self.y = self.y + (dy or 0)
end
function camera:rotate(dr)
  self.rotation = self.rotation + dr
end
function camera:scale(sx, sy)
  sx = sx or 1
  self.scaleX = self.scaleX * sx
  self.scaleY = self.scaleY * (sy or sx)
end
function camera:setPosition(x, y)
  self.x = x or self.x
  self.y = y or self.y
end
function camera:setScale(sx, sy)
  self.scaleX = sx or self.scaleX
  self.scaleY = sy or self.scaleY
end
