local bump = require 'lib.bump'
require "lib/camera"
require "player"
require "world"
require "controls"
require "canvas"

gamestate = "active"

--BUMP LIB
cols_len = 0
world = bump.newWorld()

-- Main LÖVE functions
function love.load()
  love.window.setMode(game.windowSize.width,game.windowSize.height)
  love.graphics.setBackgroundColor(0,0,0)
  math.randomseed(os.time())
  --LOAD SHIT
  CANVAS_LOAD()
  WORLD_LOAD()
  PLAYER_LOAD()
end

function love.update(dt)
  cols_len = 0
  camera:follow(dt)
  PLAYER_UPDATE(dt)
end

function love.draw()
  if gamestate == "active" then
    CANVAS_STARTLOAD()
    WORLD_DRAW()
    PLAYER_DRAW()
    CANVAS_FINLOAD()
    --WORLD_DRAW()
    if physicalWorld.debug == "true" then
    love.graphics.setColor(200,200,200)
    love.graphics.print(player.speed,10,200)
    love.graphics.print(player.yvel,10,100)
    love.graphics.print(player.xvel,10,90)
    love.graphics.print(player.y,10,150)
    love.graphics.print("FPS:"..tostring(love.timer.getFPS( )), 10, 10)
  end
  end
end
