--VITAL LOVE FUNCTIONS TO TIDY THINGS UP
--LOAD THE PLAYER AND ADD TO THE WORLD
function PLAYER_LOAD()
  --DEFINE PLAYER VARIABLES
  player = {}
  player.x = 50
  player.y = 50
  player.w = 40
  player.h = 80
  player.ch = 55
  player.speed = 2500
  player.xvel = 0
  player.yvel = 0
  player.friction = 7
  player.dead = false

  player.jump = 650
  player.onGround = false
  player.running = false
  player.moving = false
  player.holdingJump = false
  player.dir = "right"

  player.gravity = physicalWorld.gravity
  -- USE BUMP TO ADD THE MOTHERCUCKER
  world:add(player, player.x, player.y, player.w, player.h)
end

function PLAYER_UPDATE(dt)
  updatePlayer(dt)
  jumpPlayer(dt)
  runPlayer(dt)
  diePlayer(dt)
end

function PLAYER_DRAW()
  drawPlayer()
end
--LEAVING THE VITAL LOVE FUNCTIONS ENTERING THE MEAT OF THAT SHIT

function updatePlayer(dt)
  --VELOCITY
  player.xvel = player.xvel * (1 - math.min(dt*player.friction, 1))
  player.yvel = player.yvel + player.gravity * (1.5 - math.min(dt*player.friction, 1)) * dt
  --KEYPRESSES
  if love.keyboard.isDown(controls.right) and player.xvel < player.speed then
    player.xvel = player.xvel + player.speed * dt
    player.moving = true
    player.dir = "right"
  end

  if love.keyboard.isDown(controls.left) and player.xvel > -player.speed then
    player.xvel = player.xvel - player.speed * dt
    player.moving = true
    player.dir = "left"
  end

  if player.xvel ~= 0 or player.yvel ~= 0 then
    player.x, player.y, cols, wrld = world:move(player, player.x + player.xvel * dt, player.y + player.yvel * dt)
  end
  
  if love.keyboard.isDown("down") then
    player.h = player.ch
        world:update(player, player.x, player.y, player.w, player.h)
  else
    player.h = 80
        world:update(player, player.x, player.y, player.w, player.h)
  end
end

function diePlayer(dt)
  local screenHeight = love.graphics.getHeight() * camera.zoom
  --TEMP DEATH FOR PLAYER
  if player.dead == true then
    love.event.quit()
  end
  if player.y > screenHeight then
    player.dead = true
  end
end

function jumpPlayer(dt)
  --THIS PREVENTS PLAYER FROM STICKING TO WALLS AND OTHER TERRIBLE,TERRIBLE THINGS
  local actualX, actualY, cols, poop = world:check(player, player.x, player.y+1)
  for i=1,poop do
    player.yvel = 0
    player.onGround = true
  end
--[[
  if player.jumpTime > 0 and love.keyboard.isDown(controls.jump) then
    player.jumpTime = player.jumpTime - dt
    player.yvel = player.yvel + player.jump * (dt/player.jumpTimeMax)
  end
  ]]--

  if love.keyboard.isDown(controls.jump) and player.yvel == 0 and player.holdingJump == false then
    player.yvel = -player.jump
    player.onGround = false
    player.holdingJump = true
  end
--HEYO, PRVENT BUNNY HOPPING ??
  function love.keyreleased(key)
     if key == controls.jump then
        player.holdingJump = false
     end
  end
--[[
  if player.yvel > 0 and player.onGround == false then
    player.h = player.h + 1
    player.w = player.w - 0.35
  else if player.onGround == true and player.yvel == 0 then
end
--]]
end

function runPlayer(dt)
local increase = 1400
 if love.keyboard.isDown(controls.run) and love.keyboard.isDown(controls.right) then
   player.xvel = player.xvel + increase * dt
   player.running = true
 end
 if love.keyboard.isDown(controls.run) and love.keyboard.isDown(controls.left) then
   player.xvel = player.xvel - increase * dt
   player.running = true
 else
   player.running = false
   end
end


--PLAYER FUNCTIONS
function composePlayer(box, r,g,b)
  love.graphics.setColor(r,g,b)
  love.graphics.rectangle("fill", box.x, box.y, box.w, box.h,15,15)
end

function drawPlayer()
  camera:set()
  composePlayer(player, 255, 32, 61)
  love.graphics.print(player.x,player.x,player.y-10)
  love.graphics.setColor(255,255,255)
  camera:unset()
end
